import * as SchemaTypes from '@admin-layout/schedule-module-core';
import { DocumentNode } from 'graphql';
import * as Apollo from '@apollo/client';
export declare const AddScheduleEventDocument: DocumentNode;
/**
 * __useAddScheduleEventMutation__
 *
 * To run a mutation, you first call `useAddScheduleEventMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useAddScheduleEventMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [addScheduleEventMutation, { data, loading, error }] = useAddScheduleEventMutation({
 *   variables: {
 *      request: // value for 'request'
 *   },
 * });
 */
export declare function useAddScheduleEventMutation(baseOptions?: Apollo.MutationHookOptions<SchemaTypes.IAddScheduleEventMutation, SchemaTypes.IAddScheduleEventMutationVariables>): Apollo.MutationTuple<SchemaTypes.IAddScheduleEventMutation, SchemaTypes.Exact<{
    request?: SchemaTypes.InputMaybe<SchemaTypes.IScheduleCreateRequest>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type AddScheduleEventMutationHookResult = ReturnType<typeof useAddScheduleEventMutation>;
export type AddScheduleEventMutationResult = Apollo.MutationResult<SchemaTypes.IAddScheduleEventMutation>;
export type AddScheduleEventMutationOptions = Apollo.BaseMutationOptions<SchemaTypes.IAddScheduleEventMutation, SchemaTypes.IAddScheduleEventMutationVariables>;
export declare const AddTimelineEventDocument: DocumentNode;
/**
 * __useAddTimelineEventMutation__
 *
 * To run a mutation, you first call `useAddTimelineEventMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useAddTimelineEventMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [addTimelineEventMutation, { data, loading, error }] = useAddTimelineEventMutation({
 *   variables: {
 *      request: // value for 'request'
 *   },
 * });
 */
export declare function useAddTimelineEventMutation(baseOptions?: Apollo.MutationHookOptions<SchemaTypes.IAddTimelineEventMutation, SchemaTypes.IAddTimelineEventMutationVariables>): Apollo.MutationTuple<SchemaTypes.IAddTimelineEventMutation, SchemaTypes.Exact<{
    request?: SchemaTypes.InputMaybe<SchemaTypes.ITimelineCreateRequest>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type AddTimelineEventMutationHookResult = ReturnType<typeof useAddTimelineEventMutation>;
export type AddTimelineEventMutationResult = Apollo.MutationResult<SchemaTypes.IAddTimelineEventMutation>;
export type AddTimelineEventMutationOptions = Apollo.BaseMutationOptions<SchemaTypes.IAddTimelineEventMutation, SchemaTypes.IAddTimelineEventMutationVariables>;
export declare const RemoveScheduleEventDocument: DocumentNode;
/**
 * __useRemoveScheduleEventMutation__
 *
 * To run a mutation, you first call `useRemoveScheduleEventMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useRemoveScheduleEventMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [removeScheduleEventMutation, { data, loading, error }] = useRemoveScheduleEventMutation({
 *   variables: {
 *      eventId: // value for 'eventId'
 *   },
 * });
 */
export declare function useRemoveScheduleEventMutation(baseOptions?: Apollo.MutationHookOptions<SchemaTypes.IRemoveScheduleEventMutation, SchemaTypes.IRemoveScheduleEventMutationVariables>): Apollo.MutationTuple<SchemaTypes.IRemoveScheduleEventMutation, SchemaTypes.Exact<{
    eventId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type RemoveScheduleEventMutationHookResult = ReturnType<typeof useRemoveScheduleEventMutation>;
export type RemoveScheduleEventMutationResult = Apollo.MutationResult<SchemaTypes.IRemoveScheduleEventMutation>;
export type RemoveScheduleEventMutationOptions = Apollo.BaseMutationOptions<SchemaTypes.IRemoveScheduleEventMutation, SchemaTypes.IRemoveScheduleEventMutationVariables>;
export declare const RemoveTimelineEventDocument: DocumentNode;
/**
 * __useRemoveTimelineEventMutation__
 *
 * To run a mutation, you first call `useRemoveTimelineEventMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useRemoveTimelineEventMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [removeTimelineEventMutation, { data, loading, error }] = useRemoveTimelineEventMutation({
 *   variables: {
 *      eventId: // value for 'eventId'
 *   },
 * });
 */
export declare function useRemoveTimelineEventMutation(baseOptions?: Apollo.MutationHookOptions<SchemaTypes.IRemoveTimelineEventMutation, SchemaTypes.IRemoveTimelineEventMutationVariables>): Apollo.MutationTuple<SchemaTypes.IRemoveTimelineEventMutation, SchemaTypes.Exact<{
    eventId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type RemoveTimelineEventMutationHookResult = ReturnType<typeof useRemoveTimelineEventMutation>;
export type RemoveTimelineEventMutationResult = Apollo.MutationResult<SchemaTypes.IRemoveTimelineEventMutation>;
export type RemoveTimelineEventMutationOptions = Apollo.BaseMutationOptions<SchemaTypes.IRemoveTimelineEventMutation, SchemaTypes.IRemoveTimelineEventMutationVariables>;
export declare const UpdateScheduleEventDocument: DocumentNode;
/**
 * __useUpdateScheduleEventMutation__
 *
 * To run a mutation, you first call `useUpdateScheduleEventMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useUpdateScheduleEventMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [updateScheduleEventMutation, { data, loading, error }] = useUpdateScheduleEventMutation({
 *   variables: {
 *      eventId: // value for 'eventId'
 *      request: // value for 'request'
 *   },
 * });
 */
export declare function useUpdateScheduleEventMutation(baseOptions?: Apollo.MutationHookOptions<SchemaTypes.IUpdateScheduleEventMutation, SchemaTypes.IUpdateScheduleEventMutationVariables>): Apollo.MutationTuple<SchemaTypes.IUpdateScheduleEventMutation, SchemaTypes.Exact<{
    eventId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
    request?: SchemaTypes.InputMaybe<SchemaTypes.IScheduleCreateRequest>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type UpdateScheduleEventMutationHookResult = ReturnType<typeof useUpdateScheduleEventMutation>;
export type UpdateScheduleEventMutationResult = Apollo.MutationResult<SchemaTypes.IUpdateScheduleEventMutation>;
export type UpdateScheduleEventMutationOptions = Apollo.BaseMutationOptions<SchemaTypes.IUpdateScheduleEventMutation, SchemaTypes.IUpdateScheduleEventMutationVariables>;
export declare const UpdateTimelineEventDocument: DocumentNode;
/**
 * __useUpdateTimelineEventMutation__
 *
 * To run a mutation, you first call `useUpdateTimelineEventMutation` within a React component and pass it any options that fit your needs.
 * When your component renders, `useUpdateTimelineEventMutation` returns a tuple that includes:
 * - A mutate function that you can call at any time to execute the mutation
 * - An object with fields that represent the current status of the mutation's execution
 *
 * @param baseOptions options that will be passed into the mutation, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options-2;
 *
 * @example
 * const [updateTimelineEventMutation, { data, loading, error }] = useUpdateTimelineEventMutation({
 *   variables: {
 *      eventId: // value for 'eventId'
 *      request: // value for 'request'
 *   },
 * });
 */
export declare function useUpdateTimelineEventMutation(baseOptions?: Apollo.MutationHookOptions<SchemaTypes.IUpdateTimelineEventMutation, SchemaTypes.IUpdateTimelineEventMutationVariables>): Apollo.MutationTuple<SchemaTypes.IUpdateTimelineEventMutation, SchemaTypes.Exact<{
    eventId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
    request?: SchemaTypes.InputMaybe<SchemaTypes.ITimelineCreateRequest>;
}>, Apollo.DefaultContext, Apollo.ApolloCache<any>>;
export type UpdateTimelineEventMutationHookResult = ReturnType<typeof useUpdateTimelineEventMutation>;
export type UpdateTimelineEventMutationResult = Apollo.MutationResult<SchemaTypes.IUpdateTimelineEventMutation>;
export type UpdateTimelineEventMutationOptions = Apollo.BaseMutationOptions<SchemaTypes.IUpdateTimelineEventMutation, SchemaTypes.IUpdateTimelineEventMutationVariables>;
export declare const GetScheduleEventsDocument: DocumentNode;
/**
 * __useGetScheduleEventsQuery__
 *
 * To run a query within a React component, call `useGetScheduleEventsQuery` and pass it any options that fit your needs.
 * When your component renders, `useGetScheduleEventsQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useGetScheduleEventsQuery({
 *   variables: {
 *      userId: // value for 'userId'
 *   },
 * });
 */
export declare function useGetScheduleEventsQuery(baseOptions?: Apollo.QueryHookOptions<SchemaTypes.IGetScheduleEventsQuery, SchemaTypes.IGetScheduleEventsQueryVariables>): Apollo.QueryResult<SchemaTypes.IGetScheduleEventsQuery, SchemaTypes.Exact<{
    userId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
}>>;
export declare function useGetScheduleEventsLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<SchemaTypes.IGetScheduleEventsQuery, SchemaTypes.IGetScheduleEventsQueryVariables>): Apollo.LazyQueryResultTuple<SchemaTypes.IGetScheduleEventsQuery, SchemaTypes.Exact<{
    userId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
}>>;
export declare function useGetScheduleEventsSuspenseQuery(baseOptions?: Apollo.SuspenseQueryHookOptions<SchemaTypes.IGetScheduleEventsQuery, SchemaTypes.IGetScheduleEventsQueryVariables>): Apollo.UseSuspenseQueryResult<SchemaTypes.IGetScheduleEventsQuery, SchemaTypes.Exact<{
    userId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
}>>;
export type GetScheduleEventsQueryHookResult = ReturnType<typeof useGetScheduleEventsQuery>;
export type GetScheduleEventsLazyQueryHookResult = ReturnType<typeof useGetScheduleEventsLazyQuery>;
export type GetScheduleEventsSuspenseQueryHookResult = ReturnType<typeof useGetScheduleEventsSuspenseQuery>;
export type GetScheduleEventsQueryResult = Apollo.QueryResult<SchemaTypes.IGetScheduleEventsQuery, SchemaTypes.IGetScheduleEventsQueryVariables>;
export declare const GetTimelineEventsDocument: DocumentNode;
/**
 * __useGetTimelineEventsQuery__
 *
 * To run a query within a React component, call `useGetTimelineEventsQuery` and pass it any options that fit your needs.
 * When your component renders, `useGetTimelineEventsQuery` returns an object from Apollo Client that contains loading, error, and data properties
 * you can use to render your UI.
 *
 * @param baseOptions options that will be passed into the query, supported options are listed on: https://www.apollographql.com/docs/react/api/react-hooks/#options;
 *
 * @example
 * const { data, loading, error } = useGetTimelineEventsQuery({
 *   variables: {
 *      userId: // value for 'userId'
 *   },
 * });
 */
export declare function useGetTimelineEventsQuery(baseOptions?: Apollo.QueryHookOptions<SchemaTypes.IGetTimelineEventsQuery, SchemaTypes.IGetTimelineEventsQueryVariables>): Apollo.QueryResult<SchemaTypes.IGetTimelineEventsQuery, SchemaTypes.Exact<{
    userId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
}>>;
export declare function useGetTimelineEventsLazyQuery(baseOptions?: Apollo.LazyQueryHookOptions<SchemaTypes.IGetTimelineEventsQuery, SchemaTypes.IGetTimelineEventsQueryVariables>): Apollo.LazyQueryResultTuple<SchemaTypes.IGetTimelineEventsQuery, SchemaTypes.Exact<{
    userId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
}>>;
export declare function useGetTimelineEventsSuspenseQuery(baseOptions?: Apollo.SuspenseQueryHookOptions<SchemaTypes.IGetTimelineEventsQuery, SchemaTypes.IGetTimelineEventsQueryVariables>): Apollo.UseSuspenseQueryResult<SchemaTypes.IGetTimelineEventsQuery, SchemaTypes.Exact<{
    userId?: SchemaTypes.InputMaybe<SchemaTypes.Scalars["String"]["input"]>;
}>>;
export type GetTimelineEventsQueryHookResult = ReturnType<typeof useGetTimelineEventsQuery>;
export type GetTimelineEventsLazyQueryHookResult = ReturnType<typeof useGetTimelineEventsLazyQuery>;
export type GetTimelineEventsSuspenseQueryHookResult = ReturnType<typeof useGetTimelineEventsSuspenseQuery>;
export type GetTimelineEventsQueryResult = Apollo.QueryResult<SchemaTypes.IGetTimelineEventsQuery, SchemaTypes.IGetTimelineEventsQueryVariables>;
