import React__default from'react';import {Calendar,momentLocalizer}from'react-big-calendar';import withDragAndDrop from'react-big-calendar/lib/addons/dragAndDrop';import moment from'moment';import {AiOutlineDelete}from'@react-icons/all-files/ai/AiOutlineDelete';import {AiOutlineSchedule}from'@react-icons/all-files/ai/AiOutlineSchedule';import TimezonePicker from'react-timezone';import {Row,Col,Form,Select,Input,Button,Popconfirm,DatePicker}from'antd';import {Modal}from'../Modal.js';import {css}from'@emotion/css';const { RangePicker } = DatePicker;
const DnDCalendar = withDragAndDrop(Calendar);
const localizer = momentLocalizer(moment);
const allViews = ['agenda', 'day', 'week', 'month'];
function SelectableCalendar({ localizer, handleAddScheduleEvent, handleUpdateScheduleEvent, events, showModal, handleOpenModal, handleCloseModal, loading, form, selectedEvent, handleSelectEvent, selectedUser, handleChangeUser, handleRemoveEvent, handleSelectSlot, }) {
    const resetModal = (e) => {
        e.preventDefault();
        form.resetFields();
    };
    const onEventDrop = ({ event, start, end, allDay }) => {
        const updateRequest = {
            start,
            end,
            allDay,
        };
        handleUpdateScheduleEvent(event.id, updateRequest);
    };
    const onEventResize = ({ event, start, end }) => {
        const updateRequest = {
            start,
            end,
        };
        handleUpdateScheduleEvent(event.id, updateRequest);
    };
    const EventComponent = ({ start, end, title }) => {
        return (React__default.createElement(React__default.Fragment, null,
            React__default.createElement("p", null, title),
            React__default.createElement("p", null, start),
            React__default.createElement("p", null, end)));
    };
    const EventAgenda = ({ event }) => {
        return (React__default.createElement("span", null,
            React__default.createElement("em", { style: { color: 'magenta' } }, event.title),
            React__default.createElement("p", null, event.desc)));
    };
    const onFinish = values => {
        const request = {
            title: values.title,
            start: moment(values.dateRange[0]).toDate(),
            end: moment(values.dateRange[1]).toDate(),
            userId: values.user,
        };
        if (selectedEvent !== -1)
            handleUpdateScheduleEvent(selectedEvent, request);
        else
            handleAddScheduleEvent(request);
    };
    const renderModalBody = () => {
        return (React__default.createElement(React__default.Fragment, null,
            React__default.createElement(Form, { labelCol: { span: 24 }, wrapperCol: { span: 24 }, layout: "vertical", onFinish: onFinish, form: form },
                React__default.createElement(Form.Item, { label: "Title", name: "title", rules: [{ required: true, message: 'Required field' }] },
                    React__default.createElement(Input, null)),
                React__default.createElement(Form.Item, { label: "User", name: "user", rules: [{ required: true, message: 'Required field' }] },
                    React__default.createElement(Select, null,
                        React__default.createElement(Select.Option, { value: "1" }, "User1"),
                        React__default.createElement(Select.Option, { value: "2" }, "User2"))),
                React__default.createElement(Form.Item, { label: "RangePicker", name: "dateRange", rules: [{ required: true, message: 'Required field' }] },
                    React__default.createElement(RangePicker, { allowClear: true, showTime: true })),
                React__default.createElement(Form.Item, { label: "Minimum Hours", name: "minHours" },
                    React__default.createElement(Input, { name: "minhours", placeholder: "5" })),
                React__default.createElement(Form.Item, { label: "Repeats", name: "repeats" },
                    React__default.createElement(Select, null,
                        React__default.createElement(Select.Option, { value: "never" }, "Never"),
                        React__default.createElement(Select.Option, { value: "yes" }, "Yes"))),
                React__default.createElement(Form.Item, null,
                    React__default.createElement(Button, { htmlType: "button", onClick: resetModal }, "Reset"),
                    "\u00A0",
                    React__default.createElement(Button, { type: "primary", htmlType: "submit", loading: loading }, "Submit"),
                    "\u00A0",
                    selectedEvent !== -1 ? (React__default.createElement(Popconfirm, { title: "Are you sure to remove event", okText: "OK", cancelText: "Cancel", onConfirm: handleRemoveEvent },
                        React__default.createElement(Button, { type: "primary", htmlType: "button", loading: loading, icon: React__default.createElement(AiOutlineDelete, { style: { fontSize: 'large' } }), danger: true }, "Remove"))) : ('')))));
    };
    return (React__default.createElement(React__default.Fragment, null,
        React__default.createElement(Row, { align: "middle", justify: "space-between", style: { marginBottom: '15px' } },
            React__default.createElement(Col, null,
                React__default.createElement("div", { style: { textAlign: 'center' } },
                    React__default.createElement("h3", null, "Attendance schedules")))),
        React__default.createElement(Row, { align: "middle", gutter: [24, 16] },
            React__default.createElement(Col, { md: 6, xs: 16, style: { top: '-10px' } },
                React__default.createElement("span", null, "Select Timezone"),
                React__default.createElement(TimezonePicker, { value: "Asia/Yerevan", onChange: timezone => console.log('New Timezone Selected:', timezone), inputProps: {
                        placeholder: 'Select Timezone...',
                        name: 'timezone',
                    } })),
            React__default.createElement(Col, { md: 6, xs: 16 },
                React__default.createElement(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size" },
                    React__default.createElement(Form.Item, { label: "Members" },
                        React__default.createElement(Select, { onChange: handleChangeUser, value: selectedUser },
                            React__default.createElement(Select.Option, { value: "" }, "All"),
                            React__default.createElement(Select.Option, { value: "1" }, "User1"),
                            React__default.createElement(Select.Option, { value: "2" }, "User2"))))),
            React__default.createElement(Col, { md: 6, xs: 16 },
                React__default.createElement("div", { className: "vertical-" },
                    React__default.createElement("a", { href: "#" },
                        React__default.createElement("span", null,
                            React__default.createElement(AiOutlineSchedule, { style: { fontSize: 'large' } })),
                        ' ',
                        "schedule settings"))),
            React__default.createElement(Col, { md: 6, xs: 16 },
                React__default.createElement("div", null,
                    React__default.createElement("span", { style: { fontWeight: 'bold' } },
                        React__default.createElement("a", { onClick: handleOpenModal }, "Add Schedule")),
                    React__default.createElement(Modal, { modalTitle: selectedEvent !== -1 ? 'Edit Schedule' : 'Create Schedule', showModal: showModal, handleClose: handleCloseModal, modalBody: renderModalBody() })))),
        React__default.createElement(DnDCalendar, { selectable: true, localizer: localizer, events: events, defaultView: "month", views: allViews, defaultDate: new Date(), onSelectEvent: handleSelectEvent, onSelectSlot: handleSelectSlot, startAccessor: "start", endAccessor: "end", titleAccessor: "title", toolbar: true, resizable: true, onEventDrop: onEventDrop, onEventResize: onEventResize, components: {
                event: EventComponent,
                agenda: {
                    event: EventAgenda,
                },
            } })));
}
function Schedule(props) {
    return (React__default.createElement("div", { className: css(stylesheet.styles) },
        React__default.createElement("div", { className: "calender-width" },
            React__default.createElement(SelectableCalendar, { localizer: localizer, ...props }))));
}
const stylesheet = {
    styles: {
        position: 'relative',
        width: '100%',
        // Default height for the Calender Scheduler view
        '& .rbc-calendar': {
            height: '100vh',
        },
        '& .sm-screen-size': {
            '@media (max-width: 768px)': {
                width: '100% !important',
            },
        },
        '& ul.jsx-4179805763': {
            zIndex: 1050,
            webkitBoxSizing: 'border-box',
            boxSizing: 'border-box',
            padding: '4px 0',
            fontSize: '13px',
            maxHeight: '100px',
            fontVariant: 'initial',
            backgroundColor: '#fff',
            borderRadius: '2px',
            outline: 'none',
            webkitBoxShadow: '0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05)',
            boxShadow: '0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05)',
        },
        '& div.jsx-4179805763': {
            marginTop: '8px',
            width: '100%',
        },
    },
};export{Schedule as default};//# sourceMappingURL=Scheduler.js.map
