import React__default,{useState,useEffect}from'react';import TimelineComponent$1,{TimelineHeaders,DateHeader}from'react-calendar-timeline';import TimezonePicker from'react-timezone';import moment from'moment';import {Form,Row,Col,Select,Button,Avatar,Input,DatePicker}from'antd';import {AiOutlineSchedule}from'@react-icons/all-files/ai/AiOutlineSchedule';import {AiOutlineUser}from'@react-icons/all-files/ai/AiOutlineUser';import {css}from'@emotion/css';import {Modal}from'../Modal.js';const { TextArea } = Input;
const { RangePicker } = DatePicker;
const resourceMap = [
    { resourceId: '1', resourceTitle: 'Project1', stackItems: true },
    { resourceId: '2', resourceTitle: 'Project2', stackItems: true },
    { resourceId: '3', resourceTitle: 'Project3', stackItems: true },
    { resourceId: '4', resourceTitle: 'Project4', stackItems: true },
    { resourceId: '5', resourceTitle: 'Project5', stackItems: true },
];
const keys = {
    groupIdKey: 'resourceId',
    groupRightTitleKey: 'rightTitle',
    groupTitleKey: 'resourceTitle',
    itemIdKey: 'id',
    itemTitleKey: 'title',
    itemDivTitleKey: 'title',
    itemGroupKey: 'resourceId',
    itemTimeStartKey: 'start',
    itemTimeEndKey: 'end',
    groupLabelKey: 'resourceTitle',
};
const SM_SCREEN_SIZE = 768;
function TimelineCalendar({ handleAddSchedule, events: propEvents }) {
    const [isShowing, setIsShowing] = useState(false);
    const [events, setEvents] = React__default.useState(propEvents);
    const [selectedUser, setSelectedUser] = useState('');
    const openModal = () => {
        setIsShowing(!isShowing);
    };
    const resetModal = (e) => {
        e.preventDefault();
        form.resetFields();
    };
    const handleItemMove = (itemId, dragTime, newGroupOrder) => {
        // tslint:disable-next-line
        console.log('Moved', itemId, dragTime, newGroupOrder);
    };
    const handleItemResize = (itemId, time, edge) => {
        // tslint:disable-next-line
        console.log('Resized', itemId, time, edge);
    };
    const handleClose = () => {
        setIsShowing(false);
    };
    const handleSelectTimezone = timezone => {
        // tslint:disable-next-line
        console.log('New Timezone Selected:', timezone);
    };
    const [form] = Form.useForm();
    const onFinish = values => {
        const request = {
            title: values.title,
            start: moment(values.dateRange[0]).toDate(),
            end: moment(values.dateRange[1]).toDate(),
            userId: values.user,
            resourceId: values.project,
            desc: values.desc,
        };
        handleAddSchedule(request);
        setIsShowing(!isShowing);
        form.resetFields();
    };
    const [visibleTimeStart, setVisibleTimeStart] = useState(moment()
        .startOf('week')
        .add(1, 'day')
        .valueOf());
    const [visibleTimeEnd, setVisibleTimeEnd] = useState(window.screen.width <= SM_SCREEN_SIZE
        ? moment()
            .startOf('week')
            .add(4, 'day')
            .valueOf()
        : moment()
            .startOf('week')
            .add(1, 'week')
            .add(1, 'day')
            .valueOf());
    const onClickPrev = () => {
        const zoom = visibleTimeEnd - visibleTimeStart;
        setVisibleTimeStart(visibleTimeStart - zoom);
        setVisibleTimeEnd(visibleTimeEnd - zoom);
    };
    const onClickNext = () => {
        const zoom = visibleTimeEnd - visibleTimeStart;
        setVisibleTimeStart(visibleTimeStart + zoom);
        setVisibleTimeEnd(visibleTimeEnd + zoom);
    };
    const onChangeUser = value => {
        setSelectedUser(value);
    };
    const onResizeScreen = () => {
        console.log('onResizeScreen.innerWidth => ', window.innerWidth);
        if (window.innerWidth < SM_SCREEN_SIZE)
            setVisibleTimeEnd(moment(visibleTimeStart)
                .add('3', 'day')
                .valueOf());
        else
            setVisibleTimeEnd(moment(visibleTimeStart)
                .add('7', 'day')
                .valueOf());
    };
    useEffect(() => {
        setEvents(propEvents.filter(ev => {
            return ev.userId === selectedUser || selectedUser === '';
        }));
    }, [selectedUser]);
    useEffect(() => {
        window.addEventListener('resize', onResizeScreen);
        return () => window.removeEventListener('resize', onResizeScreen);
    });
    const renderModalBody = () => {
        return (React__default.createElement(Form, { labelCol: { span: 24 }, wrapperCol: { span: 24 }, layout: "vertical", onFinish: onFinish, form: form },
            React__default.createElement("div", { style: { margin: '15px 0px' } },
                React__default.createElement(Avatar, { style: { backgroundColor: '#3174ad' }, icon: React__default.createElement(AiOutlineUser, { style: { fontSize: 'large' } }) }),
                React__default.createElement("span", { style: { marginLeft: '10px' } }, "Cdmbase")),
            React__default.createElement(Form.Item, { label: "Title", name: "title", rules: [{ required: true, message: 'Required field' }] },
                React__default.createElement(Input, null)),
            React__default.createElement(Form.Item, { label: "User", name: "user", rules: [{ required: true, message: 'Required field' }] },
                React__default.createElement(Select, null,
                    React__default.createElement(Select.Option, { value: "1" }, "User1"),
                    React__default.createElement(Select.Option, { value: "2" }, "User2"))),
            React__default.createElement(Form.Item, { label: "Project", name: "project", rules: [{ required: true, message: 'Required field' }] },
                React__default.createElement(Select, null,
                    React__default.createElement(Select.Option, { value: "1" }, "Project1"),
                    React__default.createElement(Select.Option, { value: "2" }, "Project2"),
                    React__default.createElement(Select.Option, { value: "3" }, "Project3"),
                    React__default.createElement(Select.Option, { value: "4" }, "Project4"),
                    React__default.createElement(Select.Option, { value: "5" }, "Project5"))),
            React__default.createElement(Form.Item, { label: "DatePicker", name: "dateRange", rules: [{ required: true, message: 'Required field' }] },
                React__default.createElement(RangePicker, { showTime: true })),
            React__default.createElement(Form.Item, { label: "REASON *", name: "desc", rules: [{ required: true, message: 'Required field' }] },
                React__default.createElement(TextArea, { rows: 3, placeholder: "Reason for time" })),
            React__default.createElement(Form.Item, { label: "Note", name: "note" },
                React__default.createElement(TextArea, { placeholder: "Notes for time" })),
            React__default.createElement(Form.Item, null,
                React__default.createElement(Button, { htmlType: "button", onClick: resetModal }, "Reset"),
                "\u00A0",
                React__default.createElement(Button, { type: "primary", htmlType: "submit" }, "Submit"))));
    };
    return (React__default.createElement(React__default.Fragment, null,
        React__default.createElement(Row, { align: "middle", justify: "space-between", style: { marginBottom: '15px' } },
            React__default.createElement(Col, null,
                React__default.createElement("div", { style: { textAlign: 'center' } },
                    React__default.createElement("h3", null, "View & edit timesheets")))),
        React__default.createElement(Row, { align: "middle", gutter: [24, 16] },
            React__default.createElement(Col, { md: 6, xs: 16, style: { top: '-10px' } },
                React__default.createElement("span", null, "Select Timezone"),
                React__default.createElement(TimezonePicker, { value: "Asia/Yerevan", onChange: handleSelectTimezone, inputProps: {
                        placeholder: 'Select Timezone...',
                        name: 'timezone',
                    } })),
            React__default.createElement(Col, { md: 6, xs: 16 },
                React__default.createElement(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size" },
                    React__default.createElement(Form.Item, { label: "Members" },
                        React__default.createElement(Select, { onChange: onChangeUser, value: selectedUser },
                            React__default.createElement(Select.Option, { value: "" }, "All"),
                            React__default.createElement(Select.Option, { value: "1" }, "User1"),
                            React__default.createElement(Select.Option, { value: "2" }, "User2"))))),
            React__default.createElement(Col, { md: 6, xs: 16 },
                React__default.createElement("div", { className: "vertical-" },
                    React__default.createElement("a", { href: "#" },
                        React__default.createElement("span", null,
                            React__default.createElement(AiOutlineSchedule, { style: { fontSize: 'large' } })),
                        "Timesheet settings"))),
            React__default.createElement(Col, { md: 6, xs: 16 },
                React__default.createElement("div", null,
                    React__default.createElement("span", { style: { fontWeight: 'bold' } },
                        React__default.createElement("a", { onClick: openModal }, "Add Time")),
                    React__default.createElement(Modal, { modalTitle: "Add Time", showModal: isShowing, handleClose: handleClose, modalBody: renderModalBody() })))),
        React__default.createElement(Row, null,
            React__default.createElement(Col, null,
                React__default.createElement(Button, { onClick: onClickPrev }, " Prev "),
                React__default.createElement(Button, { onClick: onClickNext }, " Next "))),
        React__default.createElement(TimelineComponent$1, { keys: keys, groups: resourceMap, items: events, canMove: true, canResize: 'both', onItemMove: handleItemMove, onItemResize: handleItemResize, itemHeightRatio: 0.75, 
            // fullUpdate={true} its removed
            itemTouchSendsClick: false, stackItems: true, visibleTimeStart: visibleTimeStart, visibleTimeEnd: visibleTimeEnd },
            React__default.createElement(TimelineHeaders, { style: { height: 65 } },
                React__default.createElement(DateHeader, { unit: "day", labelFormat: dates => {
                        const curTime = dates[0];
                        const isToday = curTime.format('YYYY-MM-DD') === moment().format('YYYY-MM-DD');
                        return (React__default.createElement("div", { className: css(stylesheet.dateHeader) },
                            React__default.createElement("div", { className: "day", style: isToday ? { color: '#2196f3' } : {} }, curTime.format('DD')),
                            React__default.createElement("div", { className: "extra" },
                                React__default.createElement("span", { className: "week", style: isToday ? { color: '#2196f3' } : {} }, curTime.format('ddd')),
                                React__default.createElement("span", { className: "month" }, curTime.format('MMM')))));
                    }, style: { height: 100 }, intervalRenderer: ({ getIntervalProps, intervalContext, data }) => {
                        return (React__default.createElement("div", { ...getIntervalProps(), style: {
                                ...getIntervalProps().style,
                                borderRight: '1px solid #bbb',
                                height: '100%',
                            } }, intervalContext.intervalText));
                    } })))));
}
const stylesheet = {
    styles: {
        position: 'relative',
        width: '100%',
        '& .sm-screen-size': {
            '@media (max-width: 768px)': {
                width: '100% !important',
            },
        },
        '& ul.jsx-4179805763': {
            zIndex: 1050,
            webkitBoxSizing: 'border-box',
            boxSizing: 'border-box',
            padding: '4px 0',
            fontSize: '13px',
            maxHeight: '100px',
            fontVariant: 'initial',
            backgroundColor: '#fff',
            borderRadius: '2px',
            outline: 'none',
            webkitBoxShadow: '0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05)',
            boxShadow: '0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05)',
        },
        '& div.jsx-4179805763': {
            marginTop: '8px',
            width: '100%',
        },
        '& .rbc-day-slot': {
            position: 'relative',
        },
        '& .rbc-day-slot .rbc-events-container': {
            bottom: 0,
            left: 0,
            position: 'absolute',
            right: 0,
            marginRight: '10px',
            top: 0,
        },
        '& .rbc-day-slot .rbc-events-container.rbc-rtl': {
            left: '10px',
            right: 0,
        },
        '& .rbc-day-slot .rbc-event': {
            border: '1px solid #265985',
            display: 'flex',
            maxHeight: '100%',
            minHeight: '20px',
            flexFlow: 'column wrap',
            alignItems: 'flex-start',
            overflow: 'hidden',
            position: 'absolute',
        },
        '& .rbc-event': {
            border: 'none',
            boxShadow: 'none',
            margin: 0,
            padding: '2px 5px',
            backgroundColor: '#3174ad',
            borderRadius: '5px',
            color: '#fff',
            cursor: 'pointer',
            width: '100%',
            textAlign: 'left',
        },
        '& .react-calendar-timeline .rct-header-root': {
            backgroundColor: '#ffffff',
        },
        '& .rct-calendar-header > div': {
            height: '65px !important',
            '@media (max-width: 768px)': {
                height: '100% !important',
            },
        },
        '& .react-calendar-timeline': {
            border: '1px solid #bbb',
        },
        '& .react-calendar-timeline .rct-calendar-header': {
            border: 'none',
            borderRight: '1px solid #bbb',
            borderLeft: '1px solid #bbb',
        },
    },
    dateHeader: {
        display: 'flex',
        flexDirection: 'row',
        justifyContent: 'space-around',
        alignItems: 'center',
        textAlgin: 'center',
        '@media (max-width: 768px)': {
            flexDirection: 'column',
        },
        '& .day': {
            fontSize: '3em',
            fontWeight: '600',
            '@media (max-width: 768px)': {
                fontSize: '14px',
                fontWeight: '500',
            },
        },
        '& .extra': {
            display: 'flex',
            flexDirection: 'column',
            '& .week': {
                fontSize: '1.1em',
                fontWeight: '500',
                '@media (max-width: 768px)': {
                    fontSize: '12px',
                    fontWeight: '400',
                },
            },
            '& .month': {
                color: 'rgba(0,0,0, .5)',
                '@media (max-width: 768px)': {
                    display: 'none',
                },
            },
        },
    },
};
var TimelineComponent = props => {
    return (React__default.createElement("div", { className: css(stylesheet.styles) },
        React__default.createElement("div", null,
            React__default.createElement(TimelineCalendar, { ...props }))));
};export{TimelineComponent as default};//# sourceMappingURL=Timeline.js.map
